# frozen_string_literal: true

require 'execjs'
require 'stitch'

module Jsrb
  class NotFastGenerator
    def call(node)
      self.class.context.call('this.escodegen.generate', node)
    end

    class << self
      def context
        @context ||= begin
          code = Stitch::Package.new(root: "#{source_path}/", dependencies: "#{source_path}/escodegen.browser.js").compile
          ExecJS.compile(code)
        end
      end

      def source_path
        File.expand_path(File.join(File.dirname(__FILE__), './vendor'))
      end
    end
  end
end
