# frozen_string_literal: true

module Jsrb
  class Handler
    cattr_accessor :default_format
    self.default_format = Mime[:js]

    def self.call(template)
      %(js = Jsrb::Base.new; #{template.source}; js.generate_code)
    end
  end

  class Railtie < ::Rails::Railtie
    initializer :server_component do
      ActiveSupport.on_load :action_view do
        ActionView::Template.register_template_handler :jsrb, Jsrb::Handler
      end

      ActiveSupport.on_load :action_controller do
        ActionController::Renderers.add :jsrb do |obj, _options|
          send_data obj.to_s, type: Mime[:js]
        end
      end
    end
  end
end
